package com.memorynotfound.hibernate;

import javax.persistence.*;
import java.util.List;

public class App {

    public static void main (String...args) throws InterruptedException {

        EntityManagerFactory emf = Persistence.createEntityManagerFactory("mnf-pu");
        EntityManager em = emf.createEntityManager();
        em.setFlushMode(FlushModeType.COMMIT);

        int batchSize = 30;


        // - - - - - - - - - - - - - - Hibernate/JPA Batch Insert example - - - - - - - - - - - -
        em.getTransaction().begin();
        for (int i = 0; i < 100; i++){
            Book book = new Book(i, "Hibernate/JPA Batch Insert Example: " + i);
            em.persist(book);

            if (i % batchSize == 0 && i > 0) {
                em.flush();
            }
        }
        em.getTransaction().commit();



        // - - - - - - - - - - - - - - Hibernate/JPA Batch Update example - - - - - - - - - - - -
        List<Book> books = em.createQuery("From Book", Book.class).getResultList();

        em.getTransaction().begin();
        for (int i = 0; i < books.size(); i++){
            Book book = books.get(i);
            book.setTitle("Hibernate/JPA Batch Update Example: " + i);
            em.persist(book);

            if (i % batchSize == 0 && i > 0) {
                em.flush();
            }
        }
        em.getTransaction().commit();

        emf.close();
    }
}
